// jntsvc.h
//
// Created 03/17/99
//
// (C)Copyright 1999 Microsoft Corporation, All rights reserved.
//

#ifndef __JNTSVC_H__
#define __JNTSVC_H__

#ifdef __cplusplus
extern "C" {
#endif


// When the service process is loaded, the hook library will be loaded immediately after the service:
// 1. registers the handler for the first started service
// 2. reports a SERVICE_START_PENDING status with at least a 30 second timeout
// 3. calls some variant of CoInitialize
//
// If the library fails to load, the service will record an error message in
// the event log and terminate.
//
// JNTSVCServiceMainHook, if exported, will also be invoked at this time.  If
// JNTSVCServiceMainHook returns a FAILED(HRESULT), a SERVICE_STOPPED status
// will be reported with this error code, and the service will terminate
// without starting any of the services.  No error message will be recorded in
// the event log; the hook DLL should do so if desired.

#define JNTSVC_SERVICEMAIN_HOOK_PROC_NAME JNTSVCServiceMainHook

typedef HRESULT __cdecl JNTSVC_SERVICEMAIN_HOOK_PROC (
        IN PVOID Reserved);


#ifdef __cplusplus
}
#endif

#endif /* __JNTSVC_H__ */

